﻿{
	function sendToRenderFarm(thisObj)
	{
		var sendToRenderFarmData = new Object();
		sendToRenderFarmData.scriptName = "Send to BackBurner Render Farm";
		sendToRenderFarmData.scriptTitle = sendToRenderFarmData.scriptName + " v1.4";

		sendToRenderFarmData.strParametersPnl= "Render Farm Parameters";
		sendToRenderFarmData.strServerCount = "Server Count";
		sendToRenderFarmData.strPacketSize= "Packet Size";
		sendToRenderFarmData.strPriority= "Priority";

		sendToRenderFarmData.strSubmit = "Submit";
		sendToRenderFarmData.strHelp = "?";
		sendToRenderFarmData.strMinAE80 = "This script requires Adobe After Effects CS3 or later.";
		sendToRenderFarmData.strHelpText = 
		(
			"by Relu Pene. \n" +
			"\n" +
			"\n" +
			"Note: This version of the script requires After Effects CS3 or later. \n" + 
			"It can be used as a dockable panel by placing the script in \n "+ 
			"ScriptUI Panels subfolder of the Scripts folder, \n " + 
			"and then choosing this script from the Window menu."
		);
		
		function sendToRenderFarm_buildUI(thisObj)
		{
			var pal = (thisObj instanceof Panel) ? thisObj : new Window("palette", sendToRenderFarmData.scriptName, undefined, {resizeable:true});
			
			if (pal != null)
			{
				var res =
				"group { \
					orientation:'column', alignment:['fill','top'], \
					header: Group { \
						alignment:['fill','top'], \
						title: StaticText { text:'" + sendToRenderFarmData.scriptName + "', alignment:['fill','center'] }, \
						help: Button { text:'" + sendToRenderFarmData.strHelp +"', maximumSize:[30,20], alignment:['right','center'] }, \
					}, \
					ParametersPnl: Panel { \
						text: '" + sendToRenderFarmData.strParametersPnl + "', alignment:['fill','top'], \
						ServerCount: Group { \
							alignment:['fill','top'], margins:[0,0,0,0], \
							lbl: StaticText { text:'" + sendToRenderFarmData.strServerCount + "' , maximumSize:[90,20], alignment:['left','center'] }, \
							fld: EditText { text:'5', characters:2, alignment:['fill','center'] }, \
						}, \
						PacketSize: Group { \
							alignment:['fill','top'], margins:[0,0,0,0], \
							lbl: StaticText { text:'" + sendToRenderFarmData.strPacketSize + "', maximumSize:[90,20] , alignment:['left','center'] }, \
							fld: EditText { text:'10', characters:2, alignment:['fill','center'] }, \
						}, \
						Priority: Group { \
							alignment:['fill','top'], margins:[0,0,0,0], \
							lbl: StaticText { text:'" + sendToRenderFarmData.strPriority + "', maximumSize:[90,20] , alignment:['left','center'] }, \
							fld: EditText { text:'50', characters:2, alignment:['fill','center'] }, \
						}, \
					}, \
					submit: Group { \
						alignment:['right','top'] \
						submit: Button { text:'" + sendToRenderFarmData.strSubmit +"' }, \
					}, \
				} \
				";
				pal.grp = pal.add(res);
				
				// Workaround to ensure the edittext text color is black, even at darker UI brightness levels
				var winGfx = pal.graphics;
				var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);
				pal.grp.ParametersPnl.ServerCount.fld.graphics.foregroundColor = darkColorBrush;
				pal.grp.ParametersPnl.PacketSize.fld.graphics.foregroundColor = darkColorBrush;
				pal.grp.ParametersPnl.Priority.fld.graphics.foregroundColor = darkColorBrush;

				pal.layout.layout(true);
				pal.grp.minimumSize = pal.grp.size;
				pal.layout.resize();
				pal.onResizing = pal.onResize = function () {this.layout.resize();}
				
				pal.grp.header.help.onClick = function () {alert(sendToRenderFarmData.scriptTitle + "\n" + sendToRenderFarmData.strHelpText, sendToRenderFarmData.scriptName);}
				pal.grp.submit.submit.onClick = sendToRenderFarm_Submit;

			}
			return pal;
		}
		
		function isSecurityPrefSet(){
			var securitySetting = app.preferences.getPrefAsLong("Main Pref Section",
						"Pref_SCRIPTING_FILE_NETWORK_SECURITY");
			return (securitySetting == 1);
		}		
		
		function sendToRenderFarm_Submit(){

		clearOutput(); 

		// RENDER FARM PARAMETERS
		var renderfarm_manager = "192.168.100.1";
		var renderfarm_netmask = "255.255.255.0";
		var renderfarm_port = "3236"
		var renderfarm_group = "2D";
		var renderfarm_server_count = this.parent.parent.ParametersPnl.ServerCount.fld.text; // "10";
		var render_packet_size = this.parent.parent.ParametersPnl.PacketSize.fld.text; // 10; 
		var renderfarm_priority =  this.parent.parent.ParametersPnl.Priority.fld.text; // "50";


		// FILE PARAMETERS
		var curr_file = app.project.file;
		var curr_full_file_name = curr_file.name;
		var extPos = curr_full_file_name.lastIndexOf(".");
		var curr_file_name = curr_full_file_name.substring(0, extPos);
		var curr_file_path = curr_file.path;
		var drive_letter = curr_file.path.substring(1,2).toUpperCase();
		var complete_file_path = drive_letter + ":" + curr_file.path.substring(2,curr_file.path.length );
		var corected_file_path =  complete_file_path.replace(/\//g, "\\");

		// SUFFIX & PREFIX
		var renderfarm_job_prefix = "[AE]_";
		var all_letters = "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNMqwe"
		var random_first =  Math.round(Math.random() * 55);
		if (random_first == 0){
			random_first =1;
			}
		var random_second = Math.round(Math.random() * 55);
		if (random_second == 0){
			random_second =1;
			}
		var random_third =  Math.round(Math.random() * 55);
		if (random_third == 0){
			random_third =1;
			}
		var renderfarm_job_suffix = "_(#" + all_letters.substring(random_first, random_first + 1) + all_letters.substring(random_second, random_second + 1) + all_letters.substring(random_third, random_third + 1) + ")";


		var safeToRunScript = true;
	
		safeToRunScript = app.project != null;
		if (!app.project.file) {
			alert ("Please Save !");
			safeToRunScript = false;
			}
	
		if (safeToRunScript) {
			safeToRunScript = false;
			for (i = 1; i <= app.project.renderQueue.numItems; ++i) {
				if (app.project.renderQueue.item(i).status == RQItemStatus.QUEUED) {
					safeToRunScript = true;
					break;
				}
			}
			if (! safeToRunScript) {
				alert ("Nothing to render here!");
			}

		if (!isSecurityPrefSet()) {
			var prefWarning = "This script requires the scripting security preference to be set.\n" +
				"Go to the \"General\" panel of the application preferences and make sure " + 
				"\"Allow Scripts to Write Files and Access Network\" is checked.";	
		 
				alert(prefWarning);
				safeToRunScript = false;
			}

	}
	
		if (safeToRunScript) {
			// SAVE  PROJECT FIRST
			app.project.save();
			//  SAVE A COPY AS RENDER FILE
			var render_file_name = curr_file_name + "_renderfile";
			var render_file = File(curr_file_path + "/" + render_file_name + ".aep");
			app.project.save(render_file);

			var render_Queue  = app.project.renderQueue;
			var num_Render_Items = render_Queue.numItems;

			app.beginUndoGroup("Submit to Renderfarm");
	
				for (var i = 1; i <= num_Render_Items; i++) {
					var curItem = render_Queue.item(i);			
					if (curItem.status == RQItemStatus.QUEUED) {
						var curComp = curItem.comp;
						curCompName = curComp.name;
						var renderfarm_name = renderfarm_job_prefix + curr_file_name + "_" + curCompName + renderfarm_job_suffix;

						var workAreaStart = Math.floor(curComp.workAreaStart * curComp.frameRate) + 1;
						var workAreaEnd = Math.floor((curComp.workAreaDuration * curComp.frameRate) + workAreaStart - 1) ;
						var frame_to_render = workAreaEnd - workAreaStart;
						var nr_of_task = Math.floor(frame_to_render/render_packet_size);
						if (nr_of_task*render_packet_size < frame_to_render){
							nr_of_task = nr_of_task +1;
							}
						var task_list = new File(curr_file_path + "/" + curr_file_name + "_" + curCompName + "_tasklist.txt");
						task_list.open("w");

						// WRITE TASK LIST
						for (j=1; j <=nr_of_task; j++) {
							var sframe = workAreaStart + (j-1)*render_packet_size;
							if( (sframe / 10) < 1.0) {
								sframe = "0" + sframe;
							}
							var eframe = workAreaStart + j*render_packet_size - 1;
							if (j==nr_of_task){
								task_list.write(
								"frames " + sframe + "-" + workAreaEnd + "	" + sframe + "	" + workAreaEnd + "\n"
									)
							} else {
								task_list.write(
								"frames " + sframe + "-" + eframe + "	" + sframe + "	" + eframe + "\n"
									)
							}
						}
						task_list.close();

						// WRITE CMD JOB
						var temp_cmdjob = 
							"\"" + "C:" + "\\Program Files" + "\\Autodesk" + "\\Backburner" + "\\cmdjob.exe" + "\"" + 
							" -jobname:" + "\""+ renderfarm_name + "\"" +
							// " - NETWORK PATH:" + corected_file_path +
							" -priority:" + renderfarm_priority + " -leaveInQueue" +
							" -manager:" + renderfarm_manager +
							" -netmask:" + renderfarm_netmask +
							" -port:" + renderfarm_port +
							" -group:" + renderfarm_group +
							" -serverCount:" + renderfarm_server_count +
							" -tasklist:" + "\"" + corected_file_path +  "\\"  + curr_file_name + "_" + curCompName + "_tasklist.txt" + "\"" +
							" -taskname:1 " +
							" \"" + "C:" + "\\Program Files" + "\\Adobe" + "\\Adobe After Effects CS3" + "\\Support Files" + "\\aerender.exe" + "\"" + 
							" -project "  + "\"" + corected_file_path + "\\"  + render_file_name + ".aep"  + "\""+
							" -comp " + "\"" + curCompName + "\"" +
							" -s %tp2 -e %tp3 \n";
						
						// SEND CMDJOB
						var winOnlyCommand =  temp_cmdjob; 
						if ($.os.indexOf("Windows") == -1){
							alert ("Not available !");
						} else {
							var winCommand = "cmd /c \""+winOnlyCommand+"\"";
							system.callSystem(winCommand);
							writeLn("Comp - " + curCompName + " - was sent to Render Farm!");
						}
						}
					}
				}
				app.open(curr_file);
				app.endUndoGroup();			
			}
		
		// CHECK AFX VERSION
		if (parseFloat(app.version) < 8.0)
			alert(sendToRenderFarmData.strMinAE80, sendToRenderFarmData.scriptName);
		else
		{
			// BUILD&SHOW PALLETE
			var rdcrPal = sendToRenderFarm_buildUI(thisObj);
			if ((rdcrPal != null) && (rdcrPal instanceof Window))
			{
				rdcrPal.center();
				rdcrPal.show();
			}
			else
				rdcrPal.layout.layout(true);
		}
	}
	
	
	sendToRenderFarm(this);
}
